(* Editor+ PlugIn Interface                        *)
(* Version: 1.0.0.0                                *)
(* (c) 1997 by Christoph Bratschi                  *)
(* E-Mail: cbratschi@datacomm.ch                   *)
(* Homepage: http://www.datacomm.ch/~cbratschi/    *)
Unit EPPlugIn;

interface

uses
 OS2Def,OS2PMApi;

const
 DefPlugInFuncName    = 'EditorPlusPlugInFunc';
 DefPlugInInstallName = 'EditorPlusPlugInInstall';
 PlugInVersion : array[0..3]of Byte = (1,0,0,0);

// MR     = message result
// MP1    = message param 1
// MP2    = message param 2
// #1     = read important note at text end
// string = null terminated string
// all parameters are signed longs

// positions: 0 = first line, 1 = second, ...

const
 pim_First                 = wm_User;
 {Base messages}
 pim_Init                  = pim_First+100; {MR: result code}
 pim_End                   = pim_First+101; {MR: result code}
 pim_GetVersion            = pim_First+102; {MR: version = array[1..4]of byte, 1.00 }
 pim_GetVersionString      = pim_First+103; {MP1: buffer,MP2: buffer size,MR: bytes copied}
 pim_GetVersionStringLen   = pim_First+104; {MR: length of version string}
 pim_IsMDIVersion          = pim_First+105; {MR: 0=no,1=yes}
 pim_IsMessageSupported    = pim_First+106; {MP1: message number}
 pim_GetPlugInWindow       = pim_First+107; {MR: plug-in window handle}
 pim_InstallPlugIn         = pim_First+108; {MP1: pointer to TPlugInStruct}
 pim_DeletePlugIn          = pim_First+109; {MP1: plug-in id}
 pim_GetPlugInNr           = pim_First+110; {MR: number of plug-ins installed}
 pim_GetPlugIn             = pim_First+111; {MP1: plug-in id,MP2: pointer to TPlugInStruct #1}
 pim_SetPlugIn             = pim_First+112; {MP1: plug-in id,MP2: pointer to TPlugInStruct}
 pim_StartPlugIn           = pim_First+113; {MP1: plug-in id}
 pim_GetPlugInsRunning     = pim_First+114; {MR: number of plug-ins running}
 {PlugIn settings}
 pim_SetData               = pim_First+200; {MP1: data pointer, MP2: data size}
 pim_GetData               = pim_First+201; {MR: data pointer}
 pim_GetDataSize           = pim_First+202; {MR : data size}
 pim_CopyData              = pim_First+203; {MP1: data pointer, MP2: data size, MR: bytes copied}
 pim_SetSaveData           = pim_First+204; {MP1: options, MR: result code}
 pim_FreeString            = pim_First+205; {MP1: pointer to string}
 pim_FreePlugInStruct      = pim_First+206; {MP1: pointer to TPlugInStruct}
 pim_SetUseSharedMem       = pim_First+207; {MP1: 0=no,1=yes}
 pim_GetUseSharedMem       = pim_First+208; {MR: 0=no,1=yes}
// pim_GetMenuText           = pim_First+209;
// pim_SetMenuText           = pim_First+210; {MP1: }
// pim_GetMenuTextLen        = pim_First+211; {MR: menu text length}
// pim_GetInfoText           = pim_First+212;
// pim_SetInfoText           = pim_First+213;
// pim_GetInfoTextLen        = pim_First+214; {MR: menu text length}
 {Window handles}
 pim_GetMainWindow         = pim_First+300; {MR: window handle}
 pim_GetFileWindow         = pim_First+301; {...}
 pim_GetEditorWindow       = pim_First+302;
 pim_GetStatusBarWindow    = pim_First+303;
 pim_GetToolbarWindow      = pim_First+304;
 pim_GetMenuWindow         = pim_First+305;
 {Object handles (reserved for my own use)}
 pim_GetApplicationObject     = pim_First+400; {MR: pointer to object data}
 pim_GetMainWindowObject      = pim_First+401; {...}
 pim_GetFileWindowObject      = pim_First+402;
 pim_GetEditorWindowObject    = pim_First+403;
 pim_GetStatusBarWindowObject = pim_First+404;
 pim_GetToolbarWindowObject   = pim_First+405;
 pim_GetMenuWindowObject      = pim_First+406;
 pim_GetPrinterObject         = pim_First+407;
 {Menu commands}
 pim_Save              = pim_First+500; {MP1,MP2: wm_Command codes, MR: result code}
 pim_SaveAs            = pim_First+501;
 pim_New               = pim_First+502;
 pim_Open              = pim_First+503;
 pim_Print             = pim_First+504;
 pim_PrinterSetup      = pim_First+505;
 pim_Exit              = pim_First+506;
 pim_Find              = pim_First+507;
 pim_Replace           = pim_First+508;
 pim_FindNext          = pim_First+509;
 pim_GoToLine          = pim_First+510;
 pim_Options           = pim_First+511;
 pim_InsertMode        = pim_First+512;
 pim_OverwriteMode     = pim_First+513;
 pim_Cut               = pim_First+514;
 pim_Copy              = pim_First+515;
 pim_Paste             = pim_First+516;
 pim_Delete            = pim_First+517;
 pim_Clear             = pim_First+518;
 pim_Undo              = pim_First+519;
 pim_Redo              = pim_First+520;
 pim_SelectAll         = pim_First+521;
 pim_SaveOptions       = pim_First+522;
 pim_Calculator        = pim_First+523;
 pim_AddTool           = pim_First+524;
 pim_About             = pim_First+525;
 {Editor messages}
 pim_GetFileName           = pim_First+600; {MR: pointer to string #2}
 pim_SetFileName           = pim_First+601; {MP1: pointer to string}
 pim_IsNewFile             = pim_First+602; {MR: 0=no,1=yes}
 pim_GetBackupFile         = pim_First+603; {MR: 0=no,1=yes}
 pim_SetBackupFile         = pim_First+604; {MP1: 0=mo,1=yes}
 pim_DefaultOptions        = pim_First+605;
 pim_GetPrintStyle         = pim_First+606; {MR: 0=no,1=yes}
 pim_SetPrintStyle         = pim_First+607; {MP1: 0=no,1=yes}
 pim_GetSaveFileName       = pim_First+608; {MR: 0=no,1=yes}
 pim_SetSaveFileName       = pim_First+609; {MP1: 0=no,1=yes}
 pim_GetSaveEnvironment    = pim_First+610; {MR: 0=no,1=yes}
 pim_SetSaveEnvironment    = pim_First+611; {MP1: 0=no,1=yes}
 pim_GetXChars             = pim_First+612; {MR: horizontal chars}
 pim_GetYChars             = pim_First+613; {MR: vertical chars}
 pim_GetCursorPos          = pim_First+614; {MP1: pointer to PointL}
 pim_SetCursorPos          = pim_First+615; {MP1: pointer to PointL}
 pim_Refresh               = pim_First+616;
 pim_WaitCursor            = pim_First+617;
 pim_TextCursor            = pim_First+618;
 pim_ArrowCursor           = pim_First+619;
 pim_GetTextLen            = pim_First+620; {MR: text length}
 pim_CountWords            = pim_First+621; {MR: number of words}
 pim_GetText               = pim_First+622; {MP1: buffer,MP2: buffer size,MR: bytes copied}
 pim_SetText               = pim_First+623; {MP1: pointer to string}
 pim_Insert                = pim_First+624; {MP1: pointer to string,MP2: 1=mark}
 pim_GetInsertMode         = pim_First+625; {0=no,1=yes}
 pim_SetInsertMode         = pim_First+626; {MP1: 0=no,1=yes}
 pim_IsSelected            = pim_First+627; {MR: 0=no,1=yes}
 pim_IsModified            = pim_First+628; {MR: 0=no,1=yes}
 pim_SetModified           = pim_First+629; {MP1: 0=no,1=yes}
 pim_GetBackColor          = pim_First+630; {MR: back color}
 pim_SetBackColor          = pim_First+631; {MP1: back color}
 pim_GetTextColor          = pim_First+632; {MR: text color}
 pim_SetTextColor          = pim_First+633; {MP1: text color}
 pim_GetEndLineColor       = pim_First+634; {MR: end line color}
 pim_SetEndLineColor       = pim_First+635; {MP1: end line color}
 pim_GetTabMode            = pim_First+636; {MR: 0=no,1=yes}
 pim_SetTabMode            = pim_First+637; {MP1: 0=no,1=yes}
 pim_GetNumLines           = pim_First+638; {MR: number of lines}
 pim_GetLineLength         = pim_First+639; {MP1: line number}
 pim_GetLine               = pim_First+640; {MP1: pointer to TPIGetLineStruct}
 pim_GetLinePtr            = pim_First+641; {MP1: line number,MR: line pointer #2}
 pim_SetLine               = pim_First+642; {MP1: line number,MP2: pointer to string}
 pim_DeleteLine            = pim_First+643; {MP1: line number}
 pim_GetReadOnly           = pim_First+644; {MR: 0=no,1=yes}
 pim_SetReadOnly           = pim_First+645; {MP1: 0=no,1=yes}
 pim_GetTabWidth           = pim_First+646; {MR: tab width}
 pim_SetTabWidth           = pim_First+647; {MP1: tab width}
 pim_GetBeepOnError        = pim_First+648; {MR: 0=no,1=yes}
 pim_SetBeepOnError        = pim_First+649; {MP1: 0=no,1=yes}
 pim_GetUndoCount          = pim_First+650; {MR: undo count}
 pim_GetRedoCount          = pim_First+651; {MR: redo count}
 pim_GetUndoSize           = pim_First+652; {MR: undo size}
 pim_GetRedoSize           = pim_First+653; {MR: redo size}
 pim_CanUndo               = pim_First+654; {MR: 0=no,1=yes}
 pim_CanRedo               = pim_First+655; {MR: 0=no,1=yes}
 pim_ResetUndo             = pim_First+656;
 pim_CanPaste              = pim_First+657; {MR: 0=no,1=yes}
 pim_CanDelete             = pim_First+658; {MR: 0=no,1=yes}
 pim_CanCopy               = pim_First+659; {MR: 0=no,1=yes}
 pim_CanCut                = pim_First+660; {MR: 0=no,1=yes}
 pim_CanClear              = pim_First+661; {MR: 0=no,1=yes}
 pim_GetFirstChar          = pim_First+662; {MP1: pointer to PointL}
 pim_SetFirstChar          = pim_First+663; {MP1: pointer to PointL,MP2: move cursor 0=no,1=yes}
 pim_GetFont               = pim_First+664; {MP1: pointer to FAttrs}
 pim_SetFont               = pim_First+665; {MP1: pointer to FAttrs}
 pim_GetCharWidth          = pim_First+666; {MR: char width}
 pim_GetCharHeight         = pim_First+667; {MR: char height}
 pim_GetUnixText           = pim_First+668; {MR: 0=no,1=yes}
 pim_SetUnixText           = pim_First+669; {MP1: 0=no,1=yes}
 pim_GetMaxLineLength      = pim_First+670; {MR: max line length}
 pim_SetMaxLineLength      = pim_First+671; {reserved}
 pim_GetSelection          = pim_First+672; {MP1: pointer to TPIGetSelectionStruct}
 pim_SetSelection          = pim_First+673; {MP1: pointer to TPIGetSelectionStruct}
 pim_GetSelectedText       = pim_First+674; {MR: pointer to string #3}
 pim_GetPersistent         = pim_First+675; {MR: 0=no,1=yes}
 pim_SetPersistent         = pim_First+676; {MP1: 0=no,1=yes}
 pim_Scroll                = pim_First+677; {MP1: horizontal units,MP2: vertical units}
 pim_CanSearch             = pim_First+678; {MR: 0=no,1=yes}
 pim_CanReplace            = pim_First+679; {MR: 0=no,1=yes}
 pim_CanSearchAgain        = pim_First+680; {MR: 0=no,1=yes}
 pim_CanGoToLine           = pim_First+681; {MR: 0=no,1=yes}
 pim_GetIOBufferSize       = pim_First+682; {MR: IO buffer size}
 pim_SetIOBufferSize       = pim_First+683; {MP1: IO buffer size}
 pim_GetAutoCopy           = pim_First+684; {MR: 0=no,1=yes}
 pim_SetAutoCopy           = pim_First+685; {MP1: 0=no,1=yes}
 pim_GetScrollDelay        = pim_First+686; {MR: scroll delay}
 pim_SetScrollDelay        = pim_First+687; {MP1: scroll delay}
 pim_GetUseUndo            = pim_First+688; {MR: 0=no,1=yes}
 pim_SetUseUndo            = pim_First+689; {MP1: 0=no,1=yes}
 pim_GetUseRedo            = pim_First+690; {MR: 0=no,1=yes}
 pim_SetUseRedo            = pim_First+691; {MP1: 0=no,1=yes}
 pim_GetSaveEditor         = pim_First+692; {MR: 0=no,1=yes}
 pim_SetSaveEditor         = pim_First+693; {MP1: 0=no,1=yes}
 pim_GetTabFill            = pim_First+694; {MR: 0=no,1=yes}
 pim_SetTabFill            = pim_First+695; {MP1: 0=no,1=yes}
 pim_GetSmartTab           = pim_First+696; {MR: 0=no,1=yes}
 pim_SetSmartTab           = pim_First+697; {MP1: 0=no,1=yes}
 pim_GetTruncateSpaces     = pim_First+698; {MR: 0=no,1=yes}
 pim_SetTruncateSpaces     = pim_First+699; {MP1: 0=no,1=yes}
 pim_GetPriorityClass      = pim_First+700; {MR: thread priority class}
 pim_SetPriorityClass      = pim_First+701; {MP1: thread priority class}
 pim_GetPriorityDelta      = pim_First+702; {MR: thread priority class}
 pim_SetPriorityDelta      = pim_First+703; {MP1: thread priority class}
 {Extension messages}
{+mainwindow}

 {MDI messages}

 {SetSaveData MP1}
 sd_No   = 0;
 sd_Yes  = 1;
 sd_File = 2;

type
 {$cdecl+}
 PPlugInFunc = ^TPlugInFunc;
 TPlugInFunc = Function(Window : HWnd;Param1,Param2 : LongInt) : LongInt;
 PPlugInInstall = ^TPlugInInstall;
 TPlugInInstall = Function(Window : HWnd;Param1,Param2 : LongInt) : LongInt;
 {$cdecl-}

 PPIGetLineStruct = ^TPIGetLineStruct;
 TPIGetLineStruct = record
  LineNr : LongInt;     {32Bit signed integer}
  Buffer : PChar;       {pointer to string}
  BufferSize : LongInt; {string size}
 end;

 PPIGetSelectionStruct = ^TPIGetSelectionStruct;
 TPIGetSelectionStruct = record
  StartPos : PointL;
  EndPos : PointL;
 end;

 PPlugInStruct = ^TPlugInStruct;
 TPlugInStruct = record
  Size : LongInt;
  MenuText : PChar;
  MenuInfo : PChar;
  DLLName : PChar;
  FunctionName : PChar;
  FunctionNr : LongInt;
 end;

implementation

end.

Notes:
 #1  use pim_FreePlugInStruct to free the allocated memory
 #2  if in shared memory mode then pim_FreeString must be called to free
     the allocated memory
 #3  use pim_FreeString to free memory


Documentation:
 The plug-in install function must have id 1! Actually this function isn't
 used but in future releases it is. It must install the plug-ins in the dll
 with pim_InstallPlugIn.

 Manual installation of the demo plug-in functions:
  - Activate Tools/Add in the menu
  - Fill Menu text and Info text
  - Write im Parameter:
     %PlugInDLL="PIDemo1.dll",1 then activate Tools/Install Demo Plug-ins
  - The demo plug-ins are now installed
 Format of the %PlugInDLL command:
  %PlugInDLL="DLLName"                 = Start default plug-in in DLL DLLName
  %PlugInDLL="DLLName","FunctionName"  = Start FunctionName in DLL DLLName
  %PlugInDLL="DLLName",FunctionNr      = Start Function with the ordinal
                                         number FunctionNr in DLL DLLName

